/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.ruoyi.common.core.utils.poi.ExcelUtil
 *  com.ruoyi.common.core.web.controller.BaseController
 *  com.ruoyi.common.core.web.domain.AjaxResult
 *  com.ruoyi.common.core.web.page.TableDataInfo
 *  com.ruoyi.common.log.annotation.Log
 *  com.ruoyi.common.log.enums.BusinessType
 *  com.ruoyi.common.security.annotation.RequiresPermissions
 *  com.ruoyi.system.controller.LaFilterUaController
 *  com.ruoyi.system.domain.LaFilterUa
 *  com.ruoyi.system.domain.SysConfig
 *  com.ruoyi.system.service.ILaFilterUaService
 *  com.ruoyi.system.service.ISysConfigService
 *  javax.servlet.http.HttpServletResponse
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.web.bind.annotation.DeleteMapping
 *  org.springframework.web.bind.annotation.GetMapping
 *  org.springframework.web.bind.annotation.PathVariable
 *  org.springframework.web.bind.annotation.PostMapping
 *  org.springframework.web.bind.annotation.PutMapping
 *  org.springframework.web.bind.annotation.RequestBody
 *  org.springframework.web.bind.annotation.RequestMapping
 *  org.springframework.web.bind.annotation.RestController
 */
package com.ruoyi.system.controller;

import com.ruoyi.common.core.utils.poi.ExcelUtil;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.common.core.web.page.TableDataInfo;
import com.ruoyi.common.log.annotation.Log;
import com.ruoyi.common.log.enums.BusinessType;
import com.ruoyi.common.security.annotation.RequiresPermissions;
import com.ruoyi.system.domain.LaFilterUa;
import com.ruoyi.system.domain.SysConfig;
import com.ruoyi.system.service.ILaFilterUaService;
import com.ruoyi.system.service.ISysConfigService;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.List;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping(value={"/LaFilterUa"})
public class LaFilterUaController
extends BaseController {
    @Autowired
    private ILaFilterUaService laFilterUaService;
    @Autowired
    private ISysConfigService configService;

    @RequiresPermissions(value={"system:LaFilterUa:list"})
    @GetMapping(value={"/list"})
    public TableDataInfo list(LaFilterUa laFilterUa) {
        this.startPage();
        List list = this.laFilterUaService.selectLaFilterUaList(laFilterUa);
        return this.getDataTable(list);
    }

    @RequiresPermissions(value={"system:LaFilterUa:export"})
    @Log(title="UA过滤数据", businessType=BusinessType.EXPORT)
    @PostMapping(value={"/export"})
    public void export(HttpServletResponse response, LaFilterUa laFilterUa) {
        List list = this.laFilterUaService.selectLaFilterUaList(laFilterUa);
        ExcelUtil util = new ExcelUtil(LaFilterUa.class);
        util.exportExcel(response, list, "UA过滤数据数据");
    }

    @RequiresPermissions(value={"system:LaFilterUa:query"})
    @GetMapping(value={"/{uaId}"})
    public AjaxResult getInfo(@PathVariable(value="uaId") Long uaId) {
        return this.success((Object)this.laFilterUaService.selectLaFilterUaByUaId(uaId));
    }

    @RequiresPermissions(value={"system:LaFilterUa:add"})
    @Log(title="UA过滤数据", businessType=BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody LaFilterUa laFilterUa) {
        int num = this.laFilterUaService.insertLaFilterUa(laFilterUa);
        this.updateVersion();
        return this.toAjax(num);
    }

    @RequiresPermissions(value={"system:LaFilterUa:edit"})
    @Log(title="UA过滤数据", businessType=BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody LaFilterUa laFilterUa) {
        int num = this.laFilterUaService.updateLaFilterUa(laFilterUa);
        this.updateVersion();
        return this.toAjax(num);
    }

    @RequiresPermissions(value={"system:LaFilterUa:remove"})
    @Log(title="UA过滤数据", businessType=BusinessType.DELETE)
    @DeleteMapping(value={"/{uaIds}"})
    public AjaxResult remove(@PathVariable Long[] uaIds) {
        int num = this.laFilterUaService.deleteLaFilterUaByUaIds(uaIds);
        this.updateVersion();
        return this.toAjax(num);
    }

    private void updateVersion() {
        SysConfig config = this.configService.selectConfigByKeyObj("client-ua-version");
        if (config != null) {
            BigDecimal version = new BigDecimal(config.getConfigValue()).add(new BigDecimal("0.01")).setScale(2, RoundingMode.HALF_EVEN);
            config.setConfigValue(version.toString());
            this.configService.updateConfig(config);
        }
    }
}

